/**
 * @file skos_explorer.js
 *
 * It contains code for AJAX requests and to call jQuery UI widgets.
 *
 */

(function($){
  Drupal.behaviors.skos_explorer = {};
  Drupal.behaviors.skos_explorer.attach = function(context, settings) {
    // begin
    $('#skos-explorer-form').submit(function() {
      return Drupal.skos_explorer.showSparqlResult(this);
    });
    $('#edit-search-in').buttonset();
    $('#edit-matchtype').buttonset();
    $('#edit-debug').button();
    $('#edit-endpoints').buttonset();
    $('#edit-lang').selectmenu({width:100});

    $('#edit-lang').change(function() {  Drupal.skos_explorer.showSparqlAlphabet(); } );
    $("#skos-explorer-tabs").tabs();
    // end
  }
  // begin functions
  Drupal.skos_explorer = Drupal.skos_explorer || {
  // start
    /**
     *
     *
     */
    getParamFromUrl: function (field) {
      var query = window.location.search.substring(1);
      var vars = query.split("&");
      for (var i=0;i<vars.length;i++) {
          var pair = vars[i].split("=");
          if (pair[0] == field) {
            return pair[1];
          }
      }
      return null;
    },
    /**
     *
     *
     */
    showSparqlAlphabet: function () {
      var url = Drupal.settings.basePath+'skos_explorer/ajax/getAlphabet/?lang='+$('#edit-lang').val();
      $.get(url,
        function(data) {
          $('#sparql-letter-menu').html(data);
        });
      return false;
    },
    /**
     *
     *
     */
    showSparqlResult: function (form) {
      var url = Drupal.settings.basePath + 'skos_explorer/ajax/getResult/?' + $(form).serialize();
      return Drupal.skos_explorer.performSparqlResultRequest(url);
    },

    /**
     *
     *
     */
    showSparqlResultByLetter: function (letter) {
      $('#edit-query').val(letter);
      $('#skos-explorer-form').submit();

      /*
      var lang = $("#edit-lang option:selected").val();
      var searchin = $("#edit-search-in input[@name='search-in']:checked").val();

      var url = Drupal.settings.basePath+'sparql/ajax/getResult/?query='+letter+'&matchtype=starts&lang='+lang+'&search-in='+searchin;

      performSparqlResultRequest(url);
      */
      return false;
    },

    /**
     *
     *
     */
    performSparqlResultRequest: function (url) {
      $('#show-query').hide();
      $('#sparql-term-title').html('');
      $('#sparql-term-definition').html('');
      $('#sparql-other-langs').html('');
      $('#sparql-related-terms').html('');
      $('#sparql-broader-terms').html('');
      $('#sparql-narrower-terms').html('');
      $('#sparql-results-container').html('').addClass('loading');
      $.get(url,
        function(data) {
        $('#sparql-results-container').html(data);
        $('#sparql-results-container').removeClass('loading');
        $('#sparql-results-container li.first a').click();
      }
    );
    return false;
    },

    /**
     *
     *
     */
    showSparqlTerm: function (uri, lang, label) {
      $('#skos-explorer-tabs').tabs('option', 'active', 0);
      $('#sparql-term-title').html('<h3>'+label+' <span class="term-language">'+lang+'</span></h3>');
      // safe a state
      // https://developers.google.com/tv/web/articles/location-hash-navigation
      document.location.hash = 'sparql-term';
      var url = Drupal.settings.basePath + 'skos_explorer/ajax/getTermByUri/?uri=' + uri + '&lang=' + lang + '&label=' + label;
       $('#sparql-term-definition').html('').addClass('loading');
       $('#sparql-other-langs').html('').addClass('loading');
       $('#sparql-related-terms').html('').addClass('loading');
       $('#sparql-broader-terms').html('').addClass('loading');
       $('#sparql-narrower-terms').html('').addClass('loading');

       $.get(url,
        function(data) {
          $('#sparql-term-definition').html(data);
          $('#sparql-term-definition').removeClass('loading');
        }
      );

       var url = Drupal.settings.basePath+'skos_explorer/ajax/getOtherLang/?uri='+uri+'&lang='+lang;

       $.get(url,
        function(data) {
          $('#sparql-other-langs').html(data);
          $('#sparql-other-langs').removeClass('loading');
         }
       );

      var url = Drupal.settings.basePath+'skos_explorer/ajax/getRelatedTerms/?uri='+uri+'&lang='+lang;

       $.get(url,
        function(data) {
          $('#sparql-related-terms').html(data);
          $('#sparql-related-terms').removeClass('loading')
         }
       );

       var url = Drupal.settings.basePath+'skos_explorer/ajax/getBroaderTerms/?uri='+uri+'&lang='+lang;

       $.get(url,
        function(data) {
          $('#sparql-broader-terms').html(data);
          $('#sparql-broader-terms').removeClass('loading')
         }
       );

       var url = Drupal.settings.basePath+'skos_explorer/ajax/getNarrowerTerms/?uri='+uri+'&lang='+lang;

       $.get(url,
        function(data) {
          $('#sparql-narrower-terms').html(data);
          $('#sparql-narrower-terms').removeClass('loading')
         }
       );

       var url = Drupal.settings.basePath+'skos_explorer/ajax/getExactMatchTerms/?uri='+uri+'&lang='+lang;

       $.get(url,
        function(data) {
          $('#sparql-exact-match-terms').html(data);
          $('#sparql-exact-match-terms').removeClass('loading')
         }
       );
       return false;
    }

    //end
  }
  // end functions
})(jQuery)

